/*************************************************************
 *     SDL Tutorial aus dem deutschen Pandora Wiki
 *     http://wiki.openpandora.de/
 *
 * 	   Hilfe und Support gibt es im offiziellen Pandora Forum
 * 	   http://forum.gp2x.de/
 *
 *     Author: Thrake
 *************************************************************/

#include "engine.h"

Engine::Engine()
{

}

Engine::~Engine()
{

}

bool Engine::init()
{

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
    	std::cerr << "Fehler: libSDL wurde nicht gefunden" << std::endl;
        return false;
    }

    screen = SDL_SetVideoMode( SWIGHT, SHEIGHT, SBPP , SDL_SWSURFACE );
    if( screen == NULL ) return false;

    SDL_WM_SetCaption( "Hello World", NULL );

    return true;

}

SDL_Surface* Engine::getSurface(std::string filename)
{
	SDL_Surface *temp_img = NULL;

	temp_img = IMG_Load(filename.c_str());

#ifdef _DEBUG
	if (temp_img == NULL)
	{
		std::cout << "Fehler: Die Datei " << filename.c_str() << " konnte nicht gefunden werden" << std::endl;
		return NULL;
	}
#endif

	temp_img = SDL_DisplayFormat(temp_img);
	return temp_img;

}

void Engine::addSurface( int x, int y, SDL_Surface* temp_surface)
{
    SDL_Rect offset;
    offset.x = x;
    offset.y = y;

    SDL_BlitSurface( temp_surface, NULL, screen, &offset );

}

void Engine::refreshScreen()
{
	if( SDL_Flip( screen ) == -1 ) std::cerr << "Fehler beim Aktualisieren des Screens" << std::endl;
}

